#!/bin/sh

PKG="cura-providers"

if [ $# -lt 1 ];
then
    printf "Usage: %s VERSION\n" $0
    exit 1
fi

VERSION=$1

git tag | grep --silent "^$VERSION$"

if [ $? -ne 0 ];
then
    printf "No such tag: $VERSION\n"
    exit 2
fi

if [ -f "$PKG-$VERSION.tar.gz" ];
then
    printf "Archive $PKG-$VERSION.tar.gz already exists\n"
    exit 3
fi

exec git archive --format=tar --prefix=$PKG-$VERSION/ $VERSION | gzip > $PKG-$VERSION.tar.gz
